<?php
if (!class_exists("Author")) header("Location: /");

$author = new Author($_GET['uri']);

if (!Endpoint_Manager::local()) throw Exception("No local dataset defined");

$equiv = $author->getEquivalents();
$equivuris = array_map(function ($a) { return $a[0]; }, $equiv);
$equivuris[] = $_GET['uri'];
if (Endpoint_Manager::local()->isThere($equivuris, true)) throw new Exception("The author is already in the dataset");

$books = $author->getBooks(false);
$types = Endpoint_Manager::local()->getEndpoint(true)->getWorkTypes();
$typeswo = array_map(function($a) { $p=explode(":", $a); return $p[1]; }, $types);
?>
				<p>Add <strong><?= $author->getName(); ?></strong> to <span style="font-family:monospace;letter-spacing:-1px;">lit<span style="font-family:serif; font-size:1.2em;">&tau;</span>era</span> 's dataset:</p>
				<form action="./" method="post" id="author">
					<input type="hidden" name="uri" value="<?= $author->getURI(); ?>" />
					<div class="row-fluid margin10">
						<div class="span5 offset1">
							<div class="controls">
								<label class="control-label" for="firstname">First name:</label>
								<input type="text" name="firstname" id="firstname" value="<?= $author->getFirstName(); ?>" />
							</div>
							<div class="controls">
								<label class="control-label" for="lastname">Last name:</label>
								<input type="text" name="lastname" id="lastname" value="<?= $author->getLastName(); ?>" />
							</div>
						</div>
						<div class="span6">
							<div class="controls">
								<label class="control-label" for="birthyear">Birth year:</label>
								<input type="text" name="birthyear" id="birthyear" value="<?= $author->getBirthYear(); ?>" />
							</div>
							<div class="controls">
								<label class="control-label" for="deathyear">Death year:</label>
								<input type="text" name="deathyear" id="deathyear" value="<?= $author->getDeathYear(); ?>" />
							</div>
						</div>
					</div>
<?php
for ($i=0; $i<count($books); $i++) {
?>
					<div class="well well-small light book">
						<a class="close remove-book">&times;</a>
						<input type="hidden" name="bookuri_<?= $i; ?>" value="<?= $books[$i]->getURI(); ?>" />
						<input type="hidden" name="bookname_<?= $i; ?>" class="title" value="<?=  strtr($books[$i]->getName(), '"', "'"); ?>" />
						<span><?=  strtr($books[$i]->getName(), '"', "'"); ?></span>
						<i class="icon-pencil"></i>
						<span class="muted"><?= $typeswo[0]; ?></span>
						<select name="booktype_<?= $i; ?>" class="hide margin0" style="width: 160px">
<?php
	for ($j=0; $j<count($types); $j++) {
?>
							<option value="<?= $types[$j]; ?>"><?= $typeswo[$j]; ?></option>
<?php
	}
?>
						</select>
					</div>
<?php
}
?>
					<div class="controls">
						<div class="input-prepend">
							<button class="btn btn-success" id="newbook"><i class="icon-plus icon-white"></i></button>
							<input type="text" name="newbook" placeholder="Add another book" />
						</div>
						<button class="btn btn-primary pull-right" onclick="checkBooks(); return false;"><i class="icon-hdd icon-white"></i> Add to dataset</button>
					</div>
				</form>
