<?php
if (!class_exists("Author")) header("Location: /");

$author = new Author($_GET['uri']);
$books = $author->getBooks(false);
?>
		<ul id="datastores" class="nav nav-tabs">
			<li class="active"><a href="#" onclick="return false;"><?= Endpoint_Manager::getEndpoint($author->getURI(), false)->getName(); ?></a></li>
			<li id="searchequivalents"><a href="#" onclick="return getEquivalents('<?= $author->getURI(); ?>');">Search in other datasets</a></li>
		</ul>
<?php
if (isset($_SESSION['equivalents']) && array_search($author->getURI(), array_map(function ($a) { return $a[0]; }, json_decode($_SESSION['equivalents']))) !== false) {
?>
		<script>$(function(){ getEquivalents('<?= $author->getURI(); ?>'); });</script>
<?php
}
if (count($books) > 0) {
?>
		<p>
			Documents published by <strong><?= $author->getName(); ?></strong> according to <em><?= Endpoint_Manager::getEndpoint($author->getURI(), false)->getName(); ?></em>:
<?php
if (Endpoint_Manager::local() && !Endpoint_Manager::local()->belongs($author->getURI()) && !Endpoint_Manager::local()->isThere($author->getURI())) {
?>
			<button class="btn btn-success pull-right" onclick="document.location.href += '&add=1';"><i class="icon-hdd icon-white"></i> Add to <span style="font-family:monospace;letter-spacing:-1px;">lit<span style="font-family:serif; font-size:1.2em;">&tau;</span>era</span> 's dataset</button>
<?php
}
?>
		</p>
		<table id="booktable" class="table">
			<thead class="pointer">
				<tr>
					<th>Title</th>
				</tr>
			</thead>
			<tbody>
<?php
	for ($i=0; $i<count($books); $i++) {
?>
				<tr>
					<td><?= $books[$i]->getName(); ?></td>
				</tr>
<?php
	}
?>
			</tbody>
		</table>
<?php
	if (Endpoint_Manager::local() && Endpoint_Manager::local()->getEndpoint() == Endpoint_Manager::getEndpoint($author->getURI(), false)->getEndpoint()) {
?>
		<div class="input-prepend" data-author="<?= $author->getURI(); ?>">
			<button class="btn btn-success" id="addbook"><i class="icon-plus icon-white"></i></button>
			<input type="text" name="addbook" placeholder="Add a new book" />
		</div>
		
		<div id="myModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
				<h3 id="myModalLabel">Add a new book</h3>
			</div>
			<div class="modal-body">
				<p>You are about to add the following entry to the dataset:</p>
				<ul>
					<li><strong id="modallabel"></strong></li>
				</ul>
				<p>
					Type of document:
					<select id="modaltype" class="margin0" style="width:130px">
<?php
		$types = Endpoint_Manager::local()->getEndpoint(true)->getWorkTypes();
		$typeswo = array_map(function($a) { $p=explode(":", $a); return $p[1]; }, $types);
		for ($i=0; $i<count($types); $i++) {
?>
						<option value="<?= $types[$i]; ?>"><?= $typeswo[$i]; ?></option>
<?php
		}
?>
					</select>
				</p>
			</div>
			<div class="modal-footer">
				<button class="btn" data-dismiss="modal" aria-hidden="true">Cancel</button>
				<button class="btn btn-success" id="confirmadd">Add</button>
			</div>
		</div>
<?php
	}
} else {
	if (strlen($author->getName()) > 1) {
?>
		<div class="alert alert-warning"><em><?= Endpoint_Manager::getEndpoint($author->getURI(), false)->getName(); ?></em> has not any records of books writen by <strong><?= $author->getName(); ?></strong>.</div>
<?php
	} else {
?>
		<div class="alert alert-error"><em><?= strip_tags($author->getURI()); ?></em> does not exist in <em><?= Endpoint_Manager::getEndpoint($author->getURI(), false)->getName(); ?></em>.</div>
<?php
	}
}
?>
