<?php
require_once(__DIR__.'/endpoint_manager.class.php');
require_once(__DIR__.'/uncat_sparql_wrapper.class.php');
require_once(__DIR__.'/cat_sparql_wrapper.class.php');

class Mediator {
	
	private $wrapper;
	
	public function __construct($endpoint) {
		$endpoint = Endpoint_Manager::getEndpoint($endpoint);
		if (count($endpoint->getWorkTypes()) > 1)
			$this->wrapper = new Cat_Sparql_Wrapper($endpoint->getEndpoint());
		else
			$this->wrapper = new Uncat_Sparql_Wrapper($endpoint->getEndpoint());
	}
	
	public function __call($name, $params) {
		return call_user_func_array(array($this->wrapper, $name), $params);
	}
	
	public function hasEquivalentTo($uris) {
		return $this->getDirectEquivalent($uris) != false;
	}
}
?>
