<?php
require_once(__DIR__.'/sparql_wrapper.class.php');

class Uncat_Sparql_Wrapper extends Sparql_Wrapper {

    public function getBooks(Criteria $crit, $type) {
		$query = "SELECT DISTINCT ".$this->bookVars()." WHERE {\n";
		$query .= $this->bookSparql();
		$query .= $this->generateSubSparql($crit, false);
		$query .= "}\nORDER BY ?book_uri\n";
		//return $query;
		
		$sparql = new Sparql($this->endpoint->getEndpoint());
		$sparql->setPrefixes($this->endpoint->getPrefixes());
		$sparql->query($query);
		$books = array();
		$map = array_flip($sparql->getColNames());
		while ($row = $sparql->getNextRow()) {
			$book = new Book($row[$map["book_uri"]]);
			$author = new Author($row[$map["author_uri"]]);
			$book->setName($row[$map["book_name"]]);
			if (isset($map["author_first_name"]))
				$author->setFirstName($row[$map["author_first_name"]]);
			if (isset($map["author_last_name"]))
				$author->setLastName($row[$map["author_last_name"]]);
			if (isset($map["author_name"]))
				$author->setName($row[$map["author_name"]]);
			$book->setAuthor($author);
			$books[] = $book;
		}
		return $books;
	}
	
	protected function bookSparql() {
		$sparql = "?book_uri a ".$this->endpoint->getVocab("type_book")." ;\n";
		$sparql .= $this->endpoint->getVocab("book_author")." ?author_uri ;\n";
		$sparql .= $this->endpoint->getVocab("book_name")." ?book_name .\n";
		$sparql .= "?author_uri a ".$this->endpoint->getVocab("type_author")." ;\n";
		if (!is_null($this->endpoint->getVocab("author_first_name")))
			$sparql .= $this->endpoint->getVocab("author_first_name")." ?author_first_name ;\n";
		if (!is_null($this->endpoint->getVocab("author_last_name")))
			$sparql .= $this->endpoint->getVocab("author_last_name")." ?author_last_name ;\n";
		$sparql .= $this->endpoint->getVocab("author_name")." ?author_name .\n";
		return $sparql;
	}
	
}
?>
