<?php
/*
 * index.php
 * 
 * Copyright 2013 Alberto Calvo García <a@albertocalvo.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */

$start = microtime(true);
require_once(__DIR__.'/config.php');
require_once(__DIR__.'/classes/endpoint_manager.class.php');
require_once(__DIR__.'/classes/author.class.php');

session_start();
?>
<!DOCTYPE html>
<html>
	<head>	
		<meta charset="UTF-8"/>
		<title>littera</title>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<link rel="stylesheet" href="css/bootstrap.min.css" type="text/css" media="screen">
		<link rel="stylesheet" href="css/bootstrap-responsive.min.css" type="text/css" media="screen">
		<link rel="stylesheet" href="css/bootstrapSwitch.css" type="text/css" media="screen">
		<link rel="stylesheet" href="css/custom.css" type="text/css">
		<script src="js/jquery-1.9.1.min.js"></script>
		<script src="js/jquery-ui-1.10.3.custom.min.js"></script>
		<script src="js/jquery.tablesorter.min.js"></script>
		<script src="js/bootstrap.min.js"></script>
		<script src="js/bootstrapSwitch.min.js"></script>
		<script src="js/custom.js"></script>
	</head>
	<body>
		<div id="wrap">

			<div class="navbar">
				<div class="navbar-inner">
					<a class="brand" href="./" style="font-family:monospace;letter-spacing:-2px;">li<span style="letter-spacing:-1px;">t<span style="font-family:serif; font-size:1.3em; color:#333;" id="tau">&tau;</span></span>era</a>
					<ul class="nav pull-right">
						<li><a href="#" class="aboutlink">About</a></li>
					</ul>
				</div>
			</div>

			<div class="container-fluid">
				<form action="./" method="get" id="search" class="well form-search">
					<fieldset>
						<legend class="search-hidden">
							Search form
							<small class="pointer">▾</small>
						</legend>
						<div class="fieldset hide">
							<div id="searchbar">
								<div id="globalmatch" class="pull-left"> </div>
								<div id="search-button" class="pull-right">
									<div class="btn-group">
										<a class="mainsearch btn btn-primary" href="#"><i class="icon-search icon-white"></i> Search</a>
										<a class="btn btn-primary dropdown-toggle" data-toggle="dropdown" href="#"><span class="caret"></span></a>
										<ul class="dropdown-menu pull-right">
<?php
$endpoints = Endpoint_Manager::getEndpoints();
usort($endpoints, function($a, $b) { $c=count($b->getWorkTypes())-count($a->getWorkTypes()); if ($c) return $c; return $a->getName()>$b->getName(); });
foreach ($endpoints as $e) {
?>
											<li><a class="mainsearch" data-store="<?= $e->getEndpoint(); ?>" href="#"><?= $e->getName(); ?></a></li>
<?php
}
$types = Endpoint_Manager::getWorkTypes(true);
?>
										</ul>
									</div>
								</div>
								<script>var types = jQuery.parseJSON('<?= JSON_encode($types); ?>');</script>
								<div id="authorbook" class="switch pull-right margin20-right" data-on-label="Works" data-off-label="Authors">
									<input type="checkbox" name="search" />
								</div>
								<div id="booktype" class="pull-right margin20-right"></div>
							</div>
							<div class="inline align-top"><a href="#" class="btn btn-success btn-mini" style="margin-top: 20px;" onclick="addSearchGroup(); return false;"><i class="icon-plus icon-white"></i> add search group</a></div>
							<input type="hidden" name="store" id="store" />
						</div>
					</fieldset>
				</form>
<?php
try {
	if (isset($_GET['store'])) {
		if ($_GET['store'] == "") {
			if (Endpoint_Manager::local()) {
				$_GET['store'] = Endpoint_Manager::local()->getEndpoint();
			} else {
				$endpoints = Endpoint_Manager::getEndpoints();
				$_GET["store"] = $endpoints[array_rand($endpoints)]->getEndpoint();
			}
		}
		require('search.php');
	} elseif (isset($_GET['uri']) && !isset($_GET['add'])) {
		require('books.php');
	} elseif (isset($_GET['uri']) && isset($_GET['add'])) {
		require('addform.php');
	} elseif (isset($_POST['uri'])) {
		$uri = Endpoint_Manager::local()->insertData($_POST);
?>
				<div class="alert alert-success"><strong>Success.</strong> Data inserted successfully. <a href="?uri=<?= $uri; ?>">View it</a></div>
<?php
	} else {
?>
				<script>$(function() { showhideSearch(); });</script>
<?php
	}
} catch (Exception $e) {
	$part = explode("\n\nSPARQL query:", $e->getMessage());
?>
				<div class="alert alert-danger fade in" id="noresults">
					<button type="button" class="close" data-dismiss="alert">&times;</button>
					<h4>Error</h4>
					<p><?= $part[0]; ?></p>
				</div>
<?php
}
?>
			</div>
			<div id="push"></div>
		</div>
		
		<div id="about" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
				<h3 id="myModalLabel">About <span style="font-family:monospace;letter-spacing:-2px;font-weight:normal;">lit<span style="font-family:serif; font-size:1.2em;">&tau;</span>era</span></h3>
			</div>
			<div class="modal-body">
				<p><span style="font-family:monospace;letter-spacing:-1px;font-weight:normal;">lit<span style="font-family:serif; font-size:1.2em;">&tau;</span>era</span> is a system developed by <strong>Alberto Calvo García</strong> in his last year project under the supervision of <strong>Dr. Arantza Illarramendi</strong> that consists on a infraestructure to <strong>federate</strong> open linked datasets. The domain chosen to do the tests is the literature, so the application comes ready to be used with <strong>DBpedia and some European libraries</strong> (in particular the Spanish, British, Swedish and Hungarian ones), but can be <strong>extended</strong> easily with another ones without having to touch the code.</p>
				<p>To sum up, the system is a <strong>web application</strong> that allows users first to <strong>query</strong> those datasets through a search form and then do a number of actions with the results.</p>
			</div>
			<div class="modal-footer">
				<button class="btn btn-primary" data-dismiss="modal" aria-hidden="true">Close</button>
			</div>
		</div>
		
		<div id="footer">
			<div class="container-fluid credit">
				<p class="text-center muted">
					<!--<abbr title="<?= round(microtime(true)-$start, 1); ?> sec">Debug</abbr>.-->
					Developed by Alberto Calvo García. <a href="#" class="aboutlink">Learn more</a>
				</p>
			</div>
		</div>
	</body>
</html>
