// GENERAL

// resize a text box to fit its (current) content
function resizeTextbox() {
		var length = $(this).val().length;
		if (length > 0 || $(this).attr('placeholder') == undefined) {
			$(this).css('width', length*7+15);
		} else if ($(this).attr('placeholder') !== undefined) {
			$(this).css('width', $(this).attr('placeholder').length*7+15);
		}
}

// show/hide the search form
function showhideSearch() {
	if ($('#search .fieldset').is(":hidden")) {
		$('#search .fieldset').slideToggle(200);
		$('#search legend').toggleClass('search-hidden');
	} else {
		$('#search .fieldset').slideToggle(200, function() {
			$('#search legend').toggleClass('search-hidden');
		});
	}
	$('#search legend small').html(($('#search legend small').html() == '▾') ? '▴' : '▾');
}

// add a search term inside a search group
function addSearchField(searchGroup) {
	if (searchGroup.find(".searchfield").length == 1) {
		var select = $("<select class=\"btn-mini pull-right\" name=\""+$(".searchgroup").last().data("num")+"_match\" style=\"width:85px;\"></select>");
		select.append("<option value=\"AND\">ALL terms</option>");
		select.append("<option value=\"OR\">ANY term</option>");
		searchGroup.find(".add").after(select);
		select.after($("<small class=\"pull-right margin2\">match</small>"));
	}
	var id = searchGroup.data("num")+"_"+(searchGroup.find(".searchfield").length+1);
	var searchField = $("<div></div>", {
		"class" : "searchfield",
		"data" : {
			"id" : id
		}
	});
	var select = $("<select></select>", {
		"name" : id+"_1",
		"style" : "width:222px; margin-right:10px;"
	});
	select.append("<option value=\"author-is\">Author's last name is</option>");
	select.append("<option value=\"author-starts\">Author's last name starts with</option>");
	select.append("<option value=\"author-contains\">Author's name contains</option>");
	select.append("<option value=\"book\">Book title contains</option>");
	var text = $("<input></input>", {
		"type" : "text",
		"name" : id+"_3"
	});
	searchField.append(select).append(text);
	text.on('keydown keyup', resizeTextbox);
	resizeTextbox.call(text);
	searchField.hide();
	searchGroup.find(".add").before(searchField);
	if (searchGroup.find(".searchfield").length == 1) searchField.show();
	else searchField.slideDown(250);
}

// add a search group to the search form
function addSearchGroup() {
	var num = $(".searchgroup").last().data("num")+1;
	var searchGroup = $("<div></div>", {
		"class" : "well well-small inline align-top light searchgroup",
		"data" : {
			"num" : num
		},
		"html" : "<fieldset class=\"margin10\"><p>Search for:</p></fieldset>"
	});
	var remove = $("<button></button>", {
		"html" : "&times;",
		"class" : "remove close",
		"click" : function() {
			var width = searchGroup.width()+parseInt(searchGroup.css('padding-right'))+parseInt(searchGroup.css('padding-left'));
			var height = searchGroup.height()+parseInt(searchGroup.css('padding-top'))+parseInt(searchGroup.css('padding-bottom'));
			searchGroup.css('width', width+'px');
			searchGroup.css('height', height+'px');
			searchGroup.css('padding', 0);
			searchGroup.children().remove();
			searchGroup.animate({width:'toggle'}, 400, function() {
				searchGroup.remove();
				checkSearchGroups();
			});
			return false;
		}
	});
	var add = $("<button></button>", {
		"href" : "#",
		"html" : "<i class=\"icon-plus icon-white\"></i> add field",
		"class" : "add btn btn-success btn-mini",
		"click" : function() { addSearchField(searchGroup); return false; }
	});
	searchGroup.prepend(remove);
	searchGroup.find("fieldset").append(add);
	addSearchField(searchGroup);
	searchGroup.hide();
	if ($(".searchgroup").length === 0) $("#searchbar").after(searchGroup);
	else $(".searchgroup").last().after(searchGroup);
	searchGroup.show(1, function() {
		var hack = searchGroup.find(".searchfield").height()-30;
		var width = searchGroup.width();
		var height = searchGroup.height()-hack;
		searchGroup.hide();
		searchGroup.css('width', width+'px');
		searchGroup.css('height', height+'px');
		searchGroup.children().hide();
		searchGroup.animate({width:'toggle'}, 400, function() {
			searchGroup.css('width', '');
			searchGroup.css('height', '');
			searchGroup.children().show();
			checkSearchGroups();
		});
	});
}

// check the number of search groups, and act accordingly
function checkSearchGroups() {
	if ($(".searchgroup").length < 2 && !$("#globalmatch").is(":empty")) {
		$("#globalmatch").fadeOut(400, function() {
			$("#globalmatch").empty();
		});
		$(".remove").hide();
	} else if ($(".searchgroup").length >= 2 && $("#globalmatch").is(":empty")) {
		var select = $("<select name=\"globalmatch\" style=\"width:120px;\"></select>");
		select.append("<option value=\"AND\">ALL groups</option>");
		select.append("<option value=\"OR\">ANY group</option>");
		$("#globalmatch").hide();
		$("#globalmatch").append(select);
		$("#globalmatch").fadeIn(400);
		select.before($("<div class=\"inline margin2\">match</div>"));
		$(".remove").show();
	}
	// nasty Gecko hack
	if ($(".searchfield").last().css("height") == "60px") {
		$('#search .searchgroup fieldset').addClass("gecko-hack");
		$('.remove').css("margin-top", "-5px");
	}
	if ($(".searchgroup").length == 1 && $('.remove').css("margin-top") == "-5px") {
		$('#search .searchgroup fieldset').removeClass("gecko-hack");
		$('.remove').css("margin-top", "");
	}
}

// WRITERS

// find and load the writer in other datastores
function getEquivalents(writer) {
	$("#searchequivalents").find("a").attr("onclick", "return false;");
	$("#searchequivalents").find("a").text("Loading...");
	$('#datastores').load('ajax.php?equivalents='+writer);
	return false;
}

// make a new search
function noresults_newsearch() {
	$("#noresults").alert('close');
	$('#noresults').bind('closed', function () {
		setTimeout(function() {
			showhideSearch();
		}, 100);
		
	});
}

// try the current search in another data store
function noresults_another(endpoint) {
	var part1 = window.location.href.indexOf("store=");
	var part2 = window.location.href.indexOf("&", part1);
	if (part2 == -1) part2 = window.location.href.length;
	window.location = window.location.href.substring(0, part1+6)+endpoint+window.location.href.substring(part2);
}

// BOOKS

// edit a book
function editBook() {
	$(this).hide();
	var input = $(this).parent().find(".title");
	input.attr("type", "text");
	input.on('keydown keyup', resizeTextbox);
	input.keydown();
	input.focus();
	input.blur(function () {
		$(this).attr("type", "hidden");
		$(this).parent().find("span").first().show();
		$(this).parent().find("span").first().text($(this).val());
	});
	input.keypress(function(event) {
		if (event.keyCode == 13) {
			$(this).blur();
			event.preventDefault();
		}
	});
}

// edit a type of book
function editType() {
	$(this).hide();
	var select = $(this).parent().find("select").show().focus();
	select.blur(function () {
		$(this).hide();
		var val = $(this).val();
		$(this).find("option").each(function() {
			if (val == $(this).val())
				$(this).parent().parent().find("span").last().text($(this).text()).show();
		});
	});
	select.keypress(function(event) {
		if (event.keyCode == 13) {
			$(this).blur();
			event.preventDefault();
		}
	});
}

// remove a book
function removeBook() {
	$(this).parent().slideUp(150, function() {
		if ($(this).parent().find(".book").length > 1) $(this).remove();
	});
	return false;
}

// check the number of search books, and act accordingly
function checkBooks() {
		var books = $('#author').find('.book');
		if ($('#author').find('.book').length > 1 || $('#author').find('.book').last().is(':visible')) {
			$('#author').submit();
		} else {
			$('#author .controls').last().before($("<div class=\"alert alert-error\"><button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button><strong>Error:</strong> Add at least one book.</div>"));
			$('#newbook').parent().find("input").last().focus();
		}
}

// this code is executed as soon as the DOM is loaded
$(function() {
	// add a first search group
	addSearchGroup();

	// make the all the title bar of the search form clickable (show/hide the form)
	$('#search legend').click(showhideSearch);

	// resize all the textboxes loaded in the original page
	$('input[type=text]').on('keydown keyup', resizeTextbox);
	$('input[type=text]').each(resizeTextbox);

	// change the color scheme of the brand on hover
	var brand = $(".brand").css('color');
	var tau = $("#tau").css('color');
	$(".brand").hover(function() {
		$(".brand").animate({color: "#333"}, 2000);
		$("#tau").animate({color: "red"}, 1000);
	}, function() {
		$(".brand").animate({color: brand}, 2000);
		$("#tau").animate({color: tau}, 1000);
	});

	// order all the tables
	$("table").tablesorter({ sortList: [[0,0]], textExtraction: getTextExtractor() });

	// if there is a list of authors, load the number of books
	// published by each one's and sort the table dinamically
	if ($("#authors").length > 0) {
		if ($("#authors tbody tr").length > 50) {
			$(".bookcol").remove();
		} else {
			$(".table-hover").trigger("sorton",[[[5,1]]]);
			$("#authors tbody tr td:last-child").each(function () {
				$(this).load('ajax.php?num_books='+$(this).data('uri'), function () {
					$(".table-hover").trigger("updateCell",[this, true]);
				});
			});
		}
	}

	// trigger editBook when one is clicked
	$(".book").each(function() {
		$(this).find("span").first().click(editBook);
	});
	
	// trigger editType when one is clicked
	$(".book").each(function() {
		$(this).find("span").last().click(editType);
	});

	// remove the book when the close button is pressed
	$(".remove-book").click(removeBook);

	// add a new book
	$("#newbook").click(function(event) {
		event.preventDefault();
		if ($(this).parent().find("input").val().length == 0) {
			$(this).parent().find("input").focus();
			return;
		}
		$("#author .alert").remove();
		var books = $('#author').find('.book');
		if (books.length > 1 || books.last().is(':visible'))
			var newbook = books.last().clone().hide();
		else
			var newbook = books.last();
		newbook.find("span").first().click(editBook);
		newbook.find("span").last().click(editType);
		newbook.find(".remove-book").click(removeBook);
		var title = newbook.find(".title");
		title.val($(this).parent().find("input").val());
		if (newbook.find("input").length > 1) newbook.find("input").first().remove();
		newbook.find('span').first().text($(this).parent().find("input").val());
		var n = +title.attr("name").substring(title.attr("name").lastIndexOf("_")+1)+1;
		title.attr("name", title.attr("name").substring(0, title.attr("name").lastIndexOf("_")+1)+n);
		newbook.find('select').attr("name", newbook.find('select').attr("name").substring(0, newbook.find('select').attr("name").lastIndexOf("_")+1)+n);
		books.last().after(newbook);
		newbook.slideDown(150);
		$(this).parent().find("input").val("");
		$(this).parent().find("input").keydown(); // trigger the event so it resizes
	});
	
	// set switch behaviour
	$('#authorbook').on('switch-change', function (e, data) {
		//alert(data.value);
		if (!data.value) {
			$("#booktype").fadeOut(400, function() {
				$("#booktype").empty();
			});
		} else {
			var select = $("<select name=\"type\" style=\"width:160px;\"></select>");
			$.each(types, function(index, value) {
				select.append('<option value="'+value+'">'+value+'</option>');
			});
			$("#booktype").hide();
			$("#booktype").append(select);
			$("#booktype").fadeIn(400);
			select.before($("<div class=\"inline margin2\">work type</div>"));
		}
	});
	
	$("#confirmadd").on("click", function() {
		var val = $("#addbook").parent().find("input").val();
		$.get('ajax.php', { addbook: val, type: $(this).parent().parent().find("select").val(), author: $('#addbook').parent().data('author') }, function(data) {
			if (data.substr(0,7) == "http://") {
				var html = $("<tr><td>"+val+"</td></tr>");
				$('#booktable tbody').append(html);
				$('#booktable tbody').trigger('addRows', [html, true]);
				setTimeout(function() {
					html.effect("highlight", {}, 1600);
				}, 500);
			} else {
				$('table').last().after($("<div class=\"alert alert-error\"><button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button><strong>Error:</strong> Can not insert the book.</div>"));
			}
		});
		$('#myModal').modal('hide');
		$("#addbook").parent().find("input").val("").keydown(); // trigger the event so it resizes
	});
	
	$("#addbook").on('click', function() {
		if ($(this).parent().find("input").val().length == 0) {
			$(this).parent().find("input").focus();
			return;
		}
		$('#myModal').modal();
		$('#modallabel').html($(this).parent().find("input").val());
	});
	
	$("#addbook").parent().find("input").keypress(function(event) {
		if (event.keyCode == 13) {
			$(this).blur();
			$("#addbook").click();
			event.preventDefault();
		}
	});
	
	$(".mainsearch").on('click', function() {
		$('#store').val($(this).data("store"));
		var empty = $('#search').find("input").filter(function() {
			return $(this).attr("type") == "text" && $(this).val().length == 0;
		});
		empty.each(function() {
			$(this).attr("placeholder", "Fill in the field");
			$(this).focus();
			$(this).keyup();
		});
		if (empty.length == 0) $('#search').submit();
		return false;
	});
	
	$(".aboutlink").on('click', function() {
		$('#about').modal('show');
		return false;
	});
});

// Details: StackOverflow (http://stackoverflow.com/a/614397/18771)
// License: cc-by-sa (http://creativecommons.org/licenses/by-sa/3.0/)
// Extends: jQuery Tablesorter 2.0+ (http://tablesorter.com)
function getTextExtractor()
{
  return (function() {
    var patternLetters = /[öäüÖÄÜáàâéèêúùûóòôÁÀÂÉÈÊÚÙÛÓÒÔß]/g;
    var patternDateDmy = /^(?:\D+)?(\d{1,2})\.(\d{1,2})\.(\d{2,4})$/;
    var lookupLetters = {
      "ä": "a", "ö": "o", "ü": "u",
      "Ä": "A", "Ö": "O", "Ü": "U",
      "á": "a", "à": "a", "â": "a",
      "é": "e", "è": "e", "ê": "e",
      "ú": "u", "ù": "u", "û": "u",
      "ó": "o", "ò": "o", "ô": "o",
      "Á": "A", "À": "A", "Â": "A",
      "É": "E", "È": "E", "Ê": "E",
      "Ú": "U", "Ù": "U", "Û": "U",
      "Ó": "O", "Ò": "O", "Ô": "O",
      "ß": "s"
    };
    var letterTranslator = function(match) { 
      return lookupLetters[match] || match;
    }
 
    return function(node) {
      var text = $.trim($(node).text());
      var date = text.match(patternDateDmy);
      if (date)
        return [date[3], date[2], date[1]].join("-");
      else
        return text.replace(patternLetters, letterTranslator);
    }
  })();
}
