<?php
if (!class_exists("Author")) header("Location: /");

require_once(__DIR__.'/classes/criteria.class.php');
require_once(__DIR__.'/classes/mediator.class.php');

$criteria = new Criteria($_GET);
$mediator = new Mediator($_GET["store"]);
/*
?>
<pre><?= $mediator->getBooks($criteria, $_GET["type"]); ?></pre>
<?php
/*/
if (isset($_GET["search"]) && $_GET["search"] == "on") {
	$books = $mediator->getBooks($criteria, $_GET["type"]);
	$results = count($books) > 0;
	if ($results) {
?>
				<table class="table table-striped table-hover">
					<thead>
						<tr class="pointer">
							<th>#</th>
							<th>Work title</th>
							<th>Author's First Name</th>
							<th>Author's Last Name</th>
						</tr>
					</thead>
					<tbody>
<?php
		for ($i=0; $i<count($books); $i++) {
?>
						<tr>
							<td><?= $i+1; ?></td>
							<td style="max-width: 400px"><?= $books[$i]->getName(); ?></td>
							<td><a href="?uri=<?= $books[$i]->getAuthor()->getURI(false); ?>"><?= $books[$i]->getAuthor()->getFirstName(); ?></a></td>
							<td><a href="?uri=<?= $books[$i]->getAuthor()->getURI(false); ?>"><?= $books[$i]->getAuthor()->getLastName(); ?></a></td>
						</tr>
<?php
		}
?>
			</tbody>
		</table>
<?php
	}
} else {
	$authors = $mediator->getAuthors($criteria);
	$results = count($authors) > 0;
	if ($results) {
?>
				<table id="authors" class="table table-striped table-hover pointer">
					<thead>
						<tr>
							<th>#</th>
							<th>First Name</th>
							<th>Last Name</th>
							<th>Birth year</th>
							<th>Death year</th>
							<th class="bookcol">Works</th>
						</tr>
					</thead>
					<tbody>
<?php
		for ($i=0; $i<count($authors); $i++) {
?>
						<tr onclick="location.href='?uri=<?= $authors[$i]->getURI(false); ?>';">
							<td><?= $i+1; ?></td>
							<td><a href="?uri=<?= $authors[$i]->getURI(false); ?>"><?= $authors[$i]->getFirstName(); ?></a></td>
							<td><a href="?uri=<?= $authors[$i]->getURI(false); ?>"><?= $authors[$i]->getLastName(); ?></a></td>
							<td><?= $authors[$i]->getBirthYear(); ?></td>
							<td><?= $authors[$i]->getDeathYear(); ?></td>
							<td class="bookcol" data-uri="<?= $authors[$i]->getURI(false); ?>"></td>
						</tr>
<?php
		}
?>
			</tbody>
		</table>
<?php
	}
}
if (!$results) {
	$endpoints = Endpoint_Manager::getEndpoints();
	do {
		$e = $endpoints[array_rand($endpoints)]->getEndpoint();
	} while ($e == $_GET['store']);
?>
		<div class="alert alert-warning fade in" id="noresults">
			<button type="button" class="close" data-dismiss="alert">&times;</button>
			<h4>No results</h4>
			<p>The search you made returned no results. You may want to try to perform the same search in another dataset, or change the parameters of the search to make it less restrictive.</p>
			<p>
				<button type="button" class="btn btn-warning" onclick="noresults_another('<?= $e; ?>');">Search in another dataset</button>
				<button type="button" class="btn" onclick="noresults_newsearch();">Make a new search</button>
			</p>
		</div>
<?php
}
//*/
?>
